' Modi:
' * einzel / Partner / gegeneinander
' * auf Zeit
' * vorgegebene Bahnenzahl / endlos
' * Schwierigkeitsgrade: Straßenbreite, Verkehrsdichte, maximale Autozahl pro Bahn
' * vorgegebene Leben - Bonusleben alle X Straßen


#include once "fbgfx.bi"
#include once "digital.bi"
#define rOben1    72
#define rLinks1   75
#define rRechts1  77
#define rUnten1   80
#define rOben2    17
#define rLinks2   30
#define rRechts2  32
#define rUnten2   31
#define MENUFARBE &h3f3f3f

enum strassenbilder
  strasseUnten = 0, strasseOben, strasseMitte, strasse1spur
end enum
enum spielende
  sieg = 1, crash, abbruch, zeitende
end enum

type TypModelle
  as any ptr bildLinks, bildRechts
  as integer breite, v
end type
type TypFahrzeug
  as integer art, x, v
end type
type TypStreifen
  as integer art, anzAuto
  as TypFahrzeug auto(2)
end type
type TypRichtung
  as integer taste(1), x, y
end type
type TypOptionen
  as integer verkehrStart, verkehrPlus, strassenbreiteStart, strassenbreitePlus, geschwindigkeit, autogeschwindigkeit
  as integer zeit, zielstreifen, schiebpos, modus
end type

declare sub spiel(spieloptionen as TypOptionen)
declare sub strasseErstellen(maxBreite as integer)
declare sub strasseErweitern(strasse() as TypStreifen, position as integer, breite as integer, opt as integer = 0)
declare sub strasseZeichnen(strasse() as TypStreifen, nr as integer, beschriftung as integer = 0)
declare sub zeitZeigen(sekunden as integer)

screenres 800, 610, 32
randomize timer
dim as integer dateinr
dim shared as integer startstreifen = 0, anzeigeY = 0
dim shared as TypModelle fahrzeugmodell(1 to 7)
dim shared as TypStreifen streifen(16)  ' mit Sicherheitspuffer am Ende!

' Richtungen definieren
dim shared as TypRichtung richtung(3)
richtung(0) = type({rUnten1,  rUnten2} ,  0,  1)
richtung(1) = type({rLinks1,  rLinks2} , -1,  0)
richtung(2) = type({rRechts1, rRechts2},  1,  0)
richtung(3) = type({rOben1,   rOben2},    0, -1)

' Bilder laden
dim shared as FB.Image ptr gras, q(1, 4), s(3), hintergrund
dim shared as FB.Image ptr anzeige
anzeige = imagecreate(800+2*240, 40*16+10)
hintergrund = imagecreate(800, 40*16+10)
gras = imagecreate(800, 40)
bload "img/gras.bmp", gras
for i as integer = 0 to 3
  q(0, i) = imagecreate(50, 50)
  q(1, i) = imagecreate(50, 50)
  s(i) = imagecreate(40, 40)
next
q(0, 4) = imagecreate(25, 25)
q(1, 4) = imagecreate(25, 25)
bload "img/q2.bmp", q(0, 0)
bload "img/q1.bmp", q(0, 1)
bload "img/q2.bmp", q(0, 2)
bload "img/q3.bmp", q(0, 3)
bload "img/qklein.bmp", q(0, 4)
bload "img/p2.bmp", q(1, 0)
bload "img/p1.bmp", q(1, 1)
bload "img/p2.bmp", q(1, 2)
bload "img/p3.bmp", q(1, 3)
bload "img/pklein.bmp", q(1, 4)
bload "img/su.bmp", s(strasseUnten)
bload "img/so.bmp", s(strasseOben)
bload "img/sm.bmp", s(strasseMitte)
bload "img/s1.bmp", s(strasse1spur)
dateinr = freefile
for i as integer = 1 to 7
  with fahrzeugmodell(i)
    ' Bildgroesse auslesen
    open "img/c" & i & "l.bmp" for binary as #dateinr
    get #dateinr, 19, .breite
    close #dateinr 
    .bildLinks  = imagecreate(.breite, 60)
    .bildRechts = imagecreate(.breite, 60)
    bload "img/c" & i & "l.bmp",.bildLinks
    bload "img/c" & i & "r.bmp",.bildRechts
    if i > 5 then .v = 8 else .v = 10
  end with
next

dim as integer auswahl, dauer(...) = { -1, 60, 120, 210, 300 }, laenge(...) = { &h7fffffff, 30, 50, 100, 200 }, mx, my, mb
dim as integer wahl(2 to 5) = { 0, 2, 2, 2 }
dim as string titel = "OPERATION  511b", spielart(2), schwer(4), menutext(6)

spielart(0) = "EINZELSPIEL"
spielart(1) = "PARTNERSPIEL"
spielart(2) = "KONKURRENZSPIEL"
schwer(0)   = "ANFAENGER"
schwer(1)   = "EINFACH"
schwer(2)   = "MITTEL"
schwer(3)   = "SCHWER"
schwer(4)   = "IRRSINN"

menutext(1) = "START"
menutext(2) = spielart(wahl(2))
menutext(3) = "ZEITDAUER " & dauer(wahl(3)) & " SEK"
menutext(4) = "STRECKE " & laenge(wahl(4)) & " STRASSEN"
menutext(5) = "SCHWIERIGKEIT " & schwer(wahl(5))
menutext(6) = "ENDE"

dim as TypOptionen spieloptionen
spieloptionen.modus               = wahl(2)
spieloptionen.zeit                = dauer(wahl(3))
spieloptionen.zielstreifen        = laenge(wahl(4))
spieloptionen.verkehrStart        = 1
spieloptionen.verkehrPlus         = 18
spieloptionen.strassenbreiteStart = 2
spieloptionen.strassenbreitePlus  = 12
spieloptionen.geschwindigkeit     = 50
spieloptionen.autogeschwindigkeit = 2
spieloptionen.schiebpos           = 240

do
  ' Menubild
  startstreifen = 0
  for i as integer = 0 to 14
    streifen(i).art = (i mod 2) and i > 1
    strasseZeichnen streifen(), i
  next
  screenlock
  put (0, 0), hintergrund, pset
  line (0, 0)-step(799, 40), MENUFARBE, bf
  for i as integer = 0 to len(titel)-1
    zeichenAsc 400 - 10*len(titel) + 20*i, 10, chr(titel[i])
  next
  for k as integer = 1 to 6
    for i as integer = 0 to len(menutext(k))-1
      zeichenAsc 400 - 10*len(menutext(k)) + 20*i, k*80 + 60, chr(menutext(k)[i]), 0
    next
  next
  screenunlock
  ' Menuaktionen
  do
    auswahl = 0
    if getmouse(mx, my,, mb) = 0 andalso mb then
      for i as integer = 1 to 6
        if my > i*80 + 50 and my < i*80 + 90 then auswahl = i : exit for
      next
    end if
    sleep 1
    if inkey = chr(255, 107) then auswahl = 6
  loop until auswahl
  if auswahl > 1 and auswahl < 6 then
    if mb = 1 then wahl(auswahl) += 1
    if mb = 2 then wahl(auswahl) -= 1
  end if
  select case auswahl
    case 1 : if mb = 1 then spiel(spieloptionen)
    case 2
      wahl(2) = (wahl(2) + ubound(spielart) + 1) mod (ubound(spielart) + 1)
      menutext(2) = spielart(wahl(2))
      spieloptionen.modus       = wahl(2)
      if wahl(2) = 0 then
        spieloptionen.schiebpos   = 160
      else
        spieloptionen.schiebpos   = 240
      end if
    case 3
      wahl(3) = (wahl(3) + ubound(dauer) + 1) mod (ubound(dauer) + 1)
      if wahl(3) = 0 then
        menutext(3) = "ZEITDAUER UNBEGRENZT"
      else
        menutext(3) = "ZEITDAUER " & dauer(wahl(3)) & " SEK"
      end if
      spieloptionen.zeit = dauer(wahl(3))
    case 4
      wahl(4) = (wahl(4) + ubound(laenge) + 1) mod (ubound(laenge) + 1)
      if wahl(4) = 0 then
        menutext(4) = "STRECKE ENDLOS"
      else
        menutext(4) = "STRECKE " & laenge(wahl(4)) & " STRASSEN"
      end if
      spieloptionen.zielstreifen = laenge(wahl(4))
    case 5
      wahl(5) = (wahl(5) + ubound(schwer) + 1) mod (ubound(schwer) + 1)
      menutext(5) = "SCHWIERIGKEIT " & schwer(wahl(5))
      select case wahl(5)
        case 0
          spieloptionen.verkehrStart        = 1
          spieloptionen.verkehrPlus         = 20
          spieloptionen.strassenbreiteStart = 2
          spieloptionen.strassenbreitePlus  = 20
          spieloptionen.geschwindigkeit     = 80
          spieloptionen.autogeschwindigkeit = 0
        case 1
          spieloptionen.verkehrStart        = 1
          spieloptionen.verkehrPlus         = 18
          spieloptionen.strassenbreiteStart = 2
          spieloptionen.strassenbreitePlus  = 15
          spieloptionen.geschwindigkeit     = 60
          spieloptionen.autogeschwindigkeit = 1
        case 2
          spieloptionen.verkehrStart        = 1
          spieloptionen.verkehrPlus         = 18
          spieloptionen.strassenbreiteStart = 2
          spieloptionen.strassenbreitePlus  = 12
          spieloptionen.geschwindigkeit     = 50
          spieloptionen.autogeschwindigkeit = 2
        case 3
          spieloptionen.verkehrStart        = 2
          spieloptionen.verkehrPlus         = 18
          spieloptionen.strassenbreiteStart = 2
          spieloptionen.strassenbreitePlus  = 15
          spieloptionen.geschwindigkeit     = 40
          spieloptionen.autogeschwindigkeit = 3
        case 4
          spieloptionen.verkehrStart        = 2
          spieloptionen.verkehrPlus         = 15
          spieloptionen.strassenbreiteStart = 2
          spieloptionen.strassenbreitePlus  = 12
          spieloptionen.geschwindigkeit     = 30
          spieloptionen.autogeschwindigkeit = 5
      end select
  end select
  do
    sleep 1
  loop until getmouse(mx, my,, mb) orelse mb = 0
loop until auswahl = 6

' aufraeumen
imagedestroy gras
imagedestroy hintergrund
for i as integer = 0 to 3
  imagedestroy q(0, i)
  imagedestroy q(1, i)
  imagedestroy s(i)
next
imagedestroy q(0, 4)
imagedestroy q(1, 4)
for i as integer = 1 to 7
  imagedestroy fahrzeugmodell(i).bildLinks
  imagedestroy fahrzeugmodell(i).bildRechts
next

sub spiel(spieloptionen as TypOptionen)
  dim as spielende ende = 0
  dim as double zeitTick, zeitSekunde
  dim as integer verkehr = spieloptionen.verkehrStart, maxStrassenbreite = spieloptionen.strassenbreiteStart
  dim as integer qx(1), qy(1) = {40, 40}, qpos(1) = {0, 0}, leben(1) = {2, 2}, walkToSavety(1) = {0, 0}, i, m
  dim as integer restzeit = spieloptionen.zeit, spielerzahl = iif(spieloptionen.modus = 0, 1, 2)
  erase streifen
  if spielerzahl = 2 then
    qx(0) = 500 : qx(1) = 300
  else
    qx(0) = int(rnd*5)*100+205
  end if
  dim as TypRichtung qrichtung(1)
  strasseErstellen(maxStrassenbreite)
  zeitTick    = timer
  zeitSekunde = timer
  do
    for i as integer = 0 to spielerzahl - 1
      ' Kuh bewegen
      if qpos(i) > 0 then qpos(i) += 1
      
      if walkToSavety(i) then
        if qrichtung(i).y <> 1 then qpos(i) = 0
        if ((qy(i) mod 40) > 10) and streifen((qy(i)\40+startstreifen+1) mod 16).art=0 then walkToSavety(i) = 0
      end if
      if qpos(i) = 0 then
        if walkToSavety(i) orelse qy(i) < 40 then
          qrichtung(i) = richtung(0)
          qpos(i) = 1
        else
          for k as integer = 0 to 3
            if multikey(richtung(k).taste(i)) then
              qrichtung(i) = richtung(k)
              qpos(i) = 1
              exit for
            end if
          next
        end if
      end if
      if qpos(i) > 0 then
        with qrichtung(i)
          if qy(i) > 39 and walkToSavety(i) = 0 andalso multikey(.taste(i)) = 0 _
                   or qx(i) + .x < 5  or qx(i) + .x > 744 _
                   or qy(i) + .y < 40 or qy(i) + .y > 559 then
            qpos(i) = 0
            qrichtung(i) = type({0, 0}, 0, 0)
          else
            qx(i) += .x*4
            qy(i) += .y*4
          end if
        end with
      end if
      ' neuen Streifen hinzufuegen
      if qy(i) = spieloptionen.schiebpos + 40 and startstreifen < spieloptionen.zielstreifen-14 then
        qy(0) -= 40
        if spielerzahl = 2 then qy(1) -= 40
        put hintergrund, (0, 0), hintergrund, (0, 40)-step(799, 609), pset
        startstreifen += 1
        strasseErweitern streifen(), startstreifen mod 16, maxStrassenbreite, (startstreifen >= spieloptionen.zielstreifen-16)
        strasseZeichnen streifen(), (startstreifen-1) mod 16, startstreifen + 15
        ' Schwierigkeitsgrad
        if (startstreifen mod spieloptionen.verkehrPlus) = 0 then verkehr += 1
        if (startstreifen mod spieloptionen.strassenbreitePlus) = 0 then maxStrassenbreite += 1
      end if
    next    
    ' neue Fahrzeuge
    for l as integer = 0 to 15
      with streifen(l)
        if .art = 0 orelse .anzAuto = 3 then continue for     ' Grasstreifen oder bereits genug Fahrzeuge
        if rnd < 1-verkehr/100/(.anzAuto+1) then continue for ' verkehrsbedingte Fahrzeugzahl
        if .art = 1 and .anzAuto > 0 andalso .auto(.anzAuto-1).x < 100 then continue for
        if .art = 2 and .anzAuto > 0 andalso _
           .auto(.anzAuto-1).x > 700 - fahrzeugmodell(.auto(.anzAuto-1).art).breite then continue for
      end with
      with streifen(l).auto(streifen(l).anzAuto)
        .art = int(rnd*7) + 1
        .v = fahrzeugmodell(.art).v + int(rnd*5) - 4 + spieloptionen.autogeschwindigkeit
        if streifen(l).art = 1 then .x = -fahrzeugmodell(.art).breite else .x = 800
      end with
      streifen(l).anzAuto += 1
    next
  
    ' Fahrzeuge bewegen
    put anzeige, (240, 0), hintergrund, pset
    for l as integer = 0 to 15
      m = (l + startstreifen) mod 16
      ' Kuh zeichnen
      for i as integer = 0 to spielerzahl - 1
        if qy(i) > l*40-50 and qy(i) <= l*40-10 andalso walkToSavety(i) = 0 or (qpos(i) mod 4) < 2 then
          put anzeige, (qx(i)+240, qy(i)), q(i, qpos(i) mod 4), trans
        end if
      next
      i = 0
      do while i < streifen(m).anzAuto
        with streifen(m).auto(i)
          ' notfalls wegen Vordermann abbremsen
          if i > 0 then
            if streifen(m).art = 1 then
              if streifen(m).auto(i-1).x - .x - fahrzeugmodell(.art).breite < 50 then
                if .v > streifen(m).auto(i-1).v then .v -= 1
              end if
            else
              if .x - streifen(m).auto(i-1).x - fahrzeugmodell(streifen(m).auto(i-1).art).breite < 50 then
                if .v > streifen(m).auto(i-1).v then .v -= 1
              end if
            end if
          end if
          if streifen(m).art = 1 then .x += .v else .x -= .v  ' vorwaerts bewegen
          for k as integer = 0 to 1
            if walkToSavety(k) = 0 then
              if qy(k) <= l*40+10 and qy(k) > l*40-40 and qx(k) > .x-50 and qx(k) < .x+fahrzeugmodell(.art).breite then
                if leben(k) > 0 then                          ' Zusammenstoss mit der Kuh
                  leben(k) -= 1
                  walkToSavety(k) = -1
                else
                  ende = crash
                end if
              end if
            end if
          next
          ' Ende der Fahrstrecke erreicht?
          if streifen(m).art = 1 then
            if .x >= 800 then
              for k as integer = i to 1
                streifen(m).auto(k) = streifen(m).auto(k+1)
              next
              streifen(m).anzAuto -= 1
            else
              put anzeige, (.x+240, l*40-20), fahrzeugModell(.art).bildRechts, trans
              i += 1
            end if
          else
            .x -= .v
            if .x <= -fahrzeugmodell(.art).breite then
              for k as integer = i to 1
                streifen(m).auto(k) = streifen(m).auto(k+1)
              next
              streifen(m).anzAuto -= 1
            else
              put anzeige, (.x+240, l*40-20), fahrzeugModell(.art).bildLinks, trans
              i += 1
            end if
          end if
        end with
      loop
    next
    dim as integer y = iif(qy(0) > qy(1), qy(0), qy(1))
    screenlock
    put (0, 0), anzeige, (240, iif(y>spieloptionen.schiebpos and startstreifen < spieloptionen.zielstreifen-14, _
                          y-spieloptionen.schiebpos, 0))-step(799, 609), pset    
    line (0, 0)-step(799, 40), MENUFARBE, bf
    for i as integer = 1 to leben(0)
      put(765 - i*30, 10), q(0, 4), trans
    next
    if spielerzahl = 2 then
      for i as integer = 1 to leben(1)
        put(i*30 + 10, 10), q(1, 4), trans
      next
    end if
    if timer - zeitSekunde >= 1 then
      restzeit -= 1
      zeitSekunde = timer
      if restzeit = -1 then ende = zeitende
    end if
    if restzeit <> -1 then zeitZeigen restzeit
    screenunlock
    do while timer - zeitTick < spieloptionen.geschwindigkeit/1000
      sleep 1
    loop
    zeitTick = timer
    if multikey(1) or inkey = chr(255, 107) then ende = abbruch
    if spieloptionen.modus = 1 then
      if qy(0) > 555 and qy(1) > 555 then ende = sieg
     else
      if y > 555 then ende = sieg
     end if
  loop until ende
end sub

sub strasseErstellen(maxBreite as integer)
  ' Strasse erstellen
  streifen(0).art = 0
  streifen(1).art = 0
  put hintergrund, (0, 0), gras, (0, 30)-(799, 39), pset
  put hintergrund, (0, 10), gras, pset
  for i as integer = 2 to 16
    strasseErweitern streifen(), i, maxBreite
  next
  for i as integer = 1 to 15
    strasseZeichnen streifen(), i, i
  next
  put anzeige, (240, 0), hintergrund, pset
  put (0, 0), anzeige, (240, anzeigeY)-step(799, 609), pset
end sub

sub strasseErweitern(strasse() as TypStreifen, position as integer, maxStrassenbreite as integer, opt as integer = 0)
  static as integer strassenbreite = 0
  if opt then
    strasse(position).art = 0
    strassenbreite = 0
  elseif strassenbreite = 0 then
    strasse(position).art = int(rnd*2)+1
    strassenbreite += 1
  elseif strassenbreite = maxStrassenbreite then
    strasse(position).art = 0
    strassenbreite = 0
  else
    strasse(position).art = int(rnd*3)
    if strasse(position).art = 0 then strassenbreite = 0 else strassenbreite += 1
  end if
  if strasse(position).art = 0 then strasse(position).anzAuto = 0
end sub

sub strasseZeichnen(strasse() as TypStreifen, nr as integer, beschriftung as integer = 0)
  if strasse(nr).art = 0 then
    put hintergrund, (0, ((nr+16-(startstreifen mod 16)) mod 16)*40+10), gras, pset
  else
    dim as any ptr bild
    if strasse((nr+15) mod 16).art = 0 then
      if strasse((nr+1) mod 16).art = 0 then bild = s(strasse1spur) else bild = s(strasseOben)
    else
      if strasse((nr+1) mod 16).art = 0 then bild = s(strasseUnten) else bild = s(strasseMitte)
    end if
    for k as integer = 0 to 19
      put hintergrund, (k*40, ((nr+16-(startstreifen mod 16)) mod 16)*40+10), bild, pset
    next
  end if
  if beschriftung > 0 then draw string hintergrund, (10, ((nr+16-(startstreifen mod 16)) mod 16)*40+20), str(beschriftung)
end sub

sub zeitZeigen(sekunden as integer)
  dim as integer s = iif(sekunden < 0, -1-sekunden, sekunden)
  dim as integer f = iif(sekunden >= 0 and sekunden < 10, &hff3f3f, &hffffff)
  zeichenNr 360, 10, s \ 600, f
  zeichenNr 380, 10, (s \ 60) mod 10, f
  zeichenNr 410, 10, (s mod 60) \ 10, f
  zeichenNr 430, 10, s mod 10, f
  circle (400, 15), 2, f,,,, f
  circle (400, 25), 2, f,,,, f
end sub
